<?php
namespace Teknisa\MAN\Controllers;

use Zeedhi\Framework\Controller\CrudWithParameterBag;
use Zeedhi\Framework\DTO\Response\Notification;
use Zeedhi\Framework\DTO\Response\Message;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DataSource\FilterCriteria;
use Teknisa\MAN\Utilities;
use Zeedhi\Framework\DTO;
use Teknisa\MAN\Services;

class BloquearCartao extends CrudWithParameterBag{
   
   protected $bloquearCartaoService;
   protected $dataSourceName = 'bloquearCartao';
   
   public function __construct ($entityManager, Utilities\Util $utilService, Manager $dataSourceManager,ParameterBag $parameterBag, Services\BloquearCartaoService $bloquearCartaoService){
        parent::__construct($dataSourceManager, $parameterBag);
        $this->bloquearCartao = $bloquearCartaoService;
        $this->utilService = $utilService;
    }
    
    public function findCartao(DTO\Request\Filter $request, DTO\Response $response){
        $this->dataSourceName = 'bloquearCartao';
        $this->parameterBagColumns = array('NRORG');
        parent::find($request,$response);
    }
        
    public function bloquearCartao(DTO\Request $request, DTO\Response $response){
        $rows = $request->getDataSet()->getRows();
        $DTBLOQUEIO = date('d-m-Y H:i:s');
        
        foreach ($rows as $k => $value) {
            $NRORG = $rows[$k]['NRORG'];
            $IDSITCONSUMI = $rows[$k]['IDSITCONSUMI'];
            $CDIDCONSUMID = $rows[$k]['CDIDCONSUMID'];
            $CDCONSUMIDOR = $rows[$k]['CDCONSUMIDOR'];
            $CDCLIENTE = $rows[$k]['CDCLIENTE'];
            if ($IDSITCONSUMI == '1'){
                $DTBLOQUEIO = null;
            }
            $params = array(
                ':NRORG'        => $NRORG,
                ':IDSITCONSUMI' => $IDSITCONSUMI,
                ':CDIDCONSUMID' => $CDIDCONSUMID,
                ':CDCONSUMIDOR' => $CDCONSUMIDOR,
                ':CDCLIENTE'    => $CDCLIENTE,
                ':DTBLOQUEIO'    => $DTBLOQUEIO
            );
                    
            $this->bloquearCartao->bloqlibcartao($params);
        }
    }
    
    public function cartaoIntervalo(DTO\Request $request, DTO\Response $response){
        $row = $request->getDataSet()->getRows();
        $CDIDCONSUMID = str_pad($row[0]['CDIDCONSUMID'],10,0);
        $CDIDCONSUMIDFIM = str_pad($row[0]['CDIDCONSUMIDFIM'],10,9);
        $IDSITCONSUMI = $row[0]['IDSITCONSUMI'];
        $NRORG = $row[0]['NRORG'];
        $DTBLOQUEIO = date('d-m-Y H:i:s');
        if ($IDSITCONSUMI == '1'){
            $DTBLOQUEIO = null;
        }
        $params = array(
            ':NRORG'            => $NRORG,
            ':CDIDCONSUMID'     => $CDIDCONSUMID,
            ':CDIDCONSUMIDFIM'  => $CDIDCONSUMIDFIM,
            ':DTBLOQUEIO'  => $DTBLOQUEIO,
            ':IDSITCONSUMI'     => $IDSITCONSUMI);
        $paramsCount = array(
            ':NRORG'            => $NRORG,
            ':CDIDCONSUMID'     => $CDIDCONSUMID,
            ':CDIDCONSUMIDFIM'  => $CDIDCONSUMIDFIM
            );
        $dataSet = $this->bloquearCartao->countIntervalo($paramsCount);
        $nrPersistedRows = count($dataSet);
        $this->bloquearCartao->bloqlibIntervalo($params);
        if($nrPersistedRows > 1)
            $response->addNotification(new Notification("{$nrPersistedRows} cartões foram alterados com sucesso", Notification::TYPE_SUCCESS));
        else {
            $response->addNotification(new Notification("0 cartões foram alterados", Notification::TYPE_ERROR));
        }
    }
    
    public function findIntervalo(){
        
    }
}