<?php
namespace Teknisa\MAN\Controllers;

use Zeedhi\Framework\Controller\CrudWithParameterBag;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Notification;
use Zeedhi\Framework\DTO\Response\Message;
use Teknisa\MAN\Utilities\Util;
use Teknisa\MAN\Services;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\Util\Functions;

class configTelaInicialCardapio extends CrudWithParameterBag {
    
    protected $utilService,
              $parameterBag,
              $fileUploaderService;
    public function __construct (Services\ConfigTelaInicialCardapioService $ConfigTelaInicialCardapioService, Services\FileUploaderService $fileUploaderService, ParameterBag $parameterBag, Manager $dataSourceManager, $crudService) {
        $this->configTelaInicialCardapioService = $ConfigTelaInicialCardapioService;
        $this->fileUploaderService              = $fileUploaderService;
        $this->parameterBag                     = $parameterBag;
        $this->dataSourceManager                = $dataSourceManager;
        $this->crudService                      = $crudService;
    }
    
    protected $dataSourceNameArray = array( 
        'configTela' => 'configTelaInicialCardapio'
    );
    
    protected $parameterBagColumns = array('NRORG', 'CDFILIAL', 'CDLOJA','CDCONFTELA');
    
    public function deleteCrud(DTO\Request\DataSet $request, DTO\Response $response) {
        try {
            $dataSet = $request->getDataSet();
            $dataSet->setDataSourceName($this->dataSourceName);
            $deletedRows = $this->dataSourceManager->delete($dataSet);
            $response->addDataSet(new DataSet($this->dataSourceName, $deletedRows));
        } catch (\Exception $e) {
            $response->setCriticalError(new DTO\Response\Error($e->getMessage(), $e->getCode(), $e->getTraceAsString()));
        }
    }
    
    public function findConfig(DTO\Request\Filter $request, DTO\Response $response) {
        $this->dataSourceName = $this->dataSourceNameArray['configTela'];
        parent::find($request, $response);
    }
    
    public function saveCrud(DTO\Request\DataSet $request, DTO\Response $response) {
        try {
            $dataSet = $request->getDataSet();
            $row = $request->getDataSet()->getRows()[0];
            
            
            if (!isset($row['MIDIACARDAPIO']) || $row['MIDIACARDAPIO'] == '') {
    	        $row['MIDIACARDAPIO'] = null;
    	    }
    	    
    	    if(isset($row['MIDIACARDAPIO'][0]['name'])){
	            $row['NMARQUIVO'] = $row['MIDIACARDAPIO'][0]['name'];
    	    }
    	    else{
    	        if ($row['TPMIDIA'] == 'Vazio'){
    	            $row['NMARQUIVO'] = null;
    	        }
    	    }
    	    
    	    if(isset($row['MIDIACARDAPIO'][0]['path'])){
                if(Functions::arrayKeyExists('MIDIACARDAPIO', $row)) {
                    print_r($row);die;
                    $this->fileUploaderService->setImageForSave($row, 'MIDIACARDAPIO', 'MIDIACARDAPIO');
                }
            }
            else{
                $this->fileUploaderService->setImageForSave($row, 'MIDIACARDAPIO', 'MIDIACARDAPIO');
            }
            
            $dataSet->setDataSourceName($this->dataSourceName);
            $persistedRows = $this->dataSourceManager->persist($dataSet);
            $response->addDataSet(new DataSet($this->dataSourceName, $persistedRows));
        } catch (\Exception $e) {
            $response->setCriticalError(new DTO\Response\Error($e->getMessage(), $e->getCode(), $e->getTraceAsString()));
        }
    }
    
    public function saveConfig(DTO\Request $request, DTO\Response $response) {
        $this->dataSourceName = $this->dataSourceNameArray['configTela'];
        $this->parameterBagColumns = $this->parameterBagColumns;
        $this->saveCrud($request, $response);
    }

    public function deleteConfig(DTO\Request $request, DTO\Response $response) {
        try {
		    $this->dataSourceName = 'configTelaInicialCardapio';
            $this->deleteCrud($request,$response);
        } catch (\Exception $e) {
            $response->setError(new DTO\Response\Error($e->getMessage(), $e->getCode(), $e->getTraceAsString()));
        }
    }
    
    private function adqNovoCodigo($NRORG,$CDLOJA,$CDFILIAL) {
        $params = array(
            ':NRORG' => $NRORG,
            ':CDLOJA' => $CDLOJA,
            ':CDFILIAL' => $CDFILIAL
        );
        
        $resultadoService = $this->configTelaInicialCardapioService->getNovoCodigo($params);
        return $resultadoService;
    }
    
    public function getNovoCodigo(DTO\Request\Row $request, DTO\Response $response) {
        $row = $request->getRow();
        $cdsNovoCodigo = $this->adqNovoCodigo($row['NRORG'],$row['CDLOJA'],$row['CDFILIAL']);
        
        
        
        print str_pad($cdsNovoCodigo[0]['NEXT_CD'], 3, "0", STR_PAD_LEFT);
        print (string)$cdsNovoCodigo[0]['NEXT_ORDEM'];
    }
    
    public function setOrdem(DTO\Request\Row $request, DTO\Response $response){
        $row = $request->getRow();
		$row['COND'] = $request->getParameters()['condicao'];
        $this->configTelaInicialCardapioService->manipuladorOrdem($row);
    }
    
    public function getOrdem(DTO\Request\Filter $request, DTO\Response $response){
        $row = $request->getFilterCriteria()->getConditions();
        
        $data = $this->configTelaInicialCardapioService->getOrdem($row);
        
        $response->addDataSet(new \Zeedhi\Framework\DataSource\DataSet('configTelaInicialCardapio/getOrdem', $data));
        
    }
    
}