<?php
    /*Feito por Victor Rangel
    Produto Odhen*/
namespace Teknisa\MAN\Services;

use Teknisa\MAN\Factories;

class GrupoOperadorService {

	protected $entityManager;

	public function __construct(\Doctrine\ORM\EntityManager $entityManager)  {
		$this->entityManager = $entityManager;
	}
	
	public function selectNrAut($params){
		$query = $this->entityManager->getConnection()->fetchAll(self::SELECT_NRAUT, $params);
		return $query;
	}
	
	public function insereOperadorGrupo($params){
		$query = $this->entityManager->getConnection()->executeQuery(self::INSERE_OPERADOR_GRUPO, $params);
	}
	
	public function deleteOperadorGrupo($params){
		$query = $this->entityManager->getConnection()->executeQuery(self::DELETE_OPERADOR_GRUPO, $params);
	}
	
	public function insereAutorizacao($params){
		$query = $this->entityManager->getConnection()->executeQuery(self::INSERE_AUTORIZACAO, $params);
	}
	
	const INSERE_OPERADOR_GRUPO = "
		INSERT
		INTO OPERGRUPOP
		  (
		    CDGRUPOPER,
		    CDOPERADOR,
		    IDMENUPRINOP,
		    NRORG
		  )
		VALUES
		  (
		    :CDGRUPOPER,
		    :CDOPERADOR,
		    'N',
		    :NRORG
		  )
	";
	
	const DELETE_OPERADOR_GRUPO = "
		DELETE FROM OPERGRUPOP WHERE CDGRUPOPER = :CDGRUPOPER AND CDOPERADOR = :CDOPERADOR
	";
	
	const INSERE_AUTORIZACAO = "
		INSERT
		INTO AUTGRUPOP
		  (
		    CDGRUPOPER,
		    IDAUTGRUPOP,
		    NRAUTGRUPOP,
		    DTINCLUSAO,
		    DTULTATU,
		    NRORGINCLUSAO,
		    CDOPERINCLUSAO,
		    NRORGULTATU,
		    CDOPERULTATU
		  )
		VALUES
		  (
		    :CDGRUPOPER,
		    :IDAUTGRUPOP,
		    :NRAUTGRUPOP,
		    :DTINCLUSAO,
		    :DTINCLUSAO,
		    :NRORG,
		    :CDOPERINCLUSAO,
		    :NRORG,
		    :CDOPERINCLUSAO
		  )
	";
	
	const SELECT_NRAUT = "
		SELECT MAX(NRAUTGRUPOP)+1 AS NRAUTGRUPOP FROM AUTGRUPOP WHERE IDAUTGRUPOP = 'INDF' AND NRORG = :NRORG
	";
}
?>