<?php

namespace Teknisa\MAN\Services;

use Doctrine\ORM\EntityManager;
use Teknisa\MAN\Utilities;

class relFechamentoCupomPendente {

	public function __construct(EntityManager $entityManager) {
      $this->entityManager = $entityManager;
  }
  
  public function find($CDFILIAL, $IDORIGEMREDZ, $CDCAIXA, $DATAINI, $DATAFIN, $STATUS, $NRORG, $CDOPERADOR) {
    $params = array(
      ":CDFILIAL" => $CDFILIAL,
      ":IDORIGEMREDZ" => $IDORIGEMREDZ,
      ":CDCAIXA" => $CDCAIXA,
      ":DATAINI" => $DATAINI,
      ":DATAFIN" => $DATAFIN,
      ":STATUS" => $STATUS,
      ":CDOPERADOR" => $CDOPERADOR,
      ":NRORG" => $NRORG
 	);
 	return $this->entityManager->getConnection()->fetchAll(self::GET_FECHAMENTO_CUPOM_PENDENTE, $params);
  }
    
  const GET_FECHAMENTO_CUPOM_PENDENTE = "
    SELECT RZ.CDFILIAL||' - '||FILIOPERLOJACAIXTUR.NMFILIAL||' Loja: '||FILIOPERLOJACAIXTUR.CDLOJA||' - '||FILIOPERLOJACAIXTUR.NMLOJA AS LABELFILIAL,
         RZ.CDCAIXA||' - '||FILIOPERLOJACAIXTUR.NMCAIXA AS LABELCAIXA,
         CASE RZ.IDSTATUS
                WHEN 'P' THEN 'Pendente'
                WHEN 'E' THEN 'Com Erro'
                WHEN 'A' THEN 'Aprovada'
                ELSE RZ.IDSTATUS
             END AS IDSTATUS, RZ.CDFILIAL, RZ.CDCAIXA, 
             RZ.IDORIGEMREDZ, RZ.NRORG, RZ.DTREDUCAOZ AS DTREDUCAOZ
      FROM REDUCAOZ RZ
      JOIN (SELECT FILIOPERLOJACAIX.CDCAIXA, FILIOPERLOJACAIX.NMCAIXA, FILIOPERLOJACAIX.CDFILIAL, FILIOPERLOJACAIX.NMFILIAL, FILIOPERLOJACAIX.CDLOJA, FILIOPERLOJACAIX.NMLOJA, FILIOPERLOJACAIX.NRORG, T.DTFECHCAIX, T.DTMOVTURCAIX
            FROM TURCAIXA T
            JOIN (SELECT C.CDCAIXA, C.NMCAIXA, FILIOPERLOJA.CDFILIAL, FILIOPERLOJA.NMFILIAL, FILIOPERLOJA.CDLOJA, FILIOPERLOJA.NMLOJA, FILIOPERLOJA.NRORG
                    FROM CAIXA C
                    JOIN (SELECT L.CDLOJA, L.NMLOJA, FILIOPER.CDFILIAL, FILIOPER.NMFILIAL, FILIOPER.NRORG
                            FROM LOJA L
                            JOIN (SELECT FO.CDFILIAL, F.NMFILIAL, FO.NRORG
                                    FROM FILIAL F
                                    JOIN (SELECT FO.CDFILIAL, FO.NRORG
                                            FROM FILIOPER FO
                                           WHERE FO.CDOPERADOR = :CDOPERADOR
                                             AND FO.NRORG = :NRORG
                                         ) FO
                                      ON F.CDFILIAL = FO.CDFILIAL
                                     AND F.NRORG = FO.NRORG
                                   WHERE ( ( INSTR(:CDFILIAL, F.CDFILIAL) >0 ) OR ( :CDFILIAL = 'T' ) )
                                 )FILIOPER
                              ON FILIOPER.CDFILIAL = L.CDFILIAL
                             AND FILIOPER.NRORG = L.NRORG
                         )FILIOPERLOJA
                      ON FILIOPERLOJA.CDFILIAL = C.CDFILIAL
                     AND FILIOPERLOJA.CDLOJA = C.CDLOJA
                     AND FILIOPERLOJA.NRORG = C.NRORG 
                   WHERE ( ( INSTR(:CDCAIXA, FILIOPERLOJA.CDFILIAL ||C.CDCAIXA) >0 ) OR ( :CDCAIXA = 'T' ) )
                 )FILIOPERLOJACAIX
              ON FILIOPERLOJACAIX.CDCAIXA = T.CDCAIXA
             AND FILIOPERLOJACAIX.CDFILIAL = T.CDFILIAL
             AND FILIOPERLOJACAIX.NRORG = T.NRORG
           WHERE T.DTFECHCAIX IS NOT NULL
             )FILIOPERLOJACAIXTUR
        ON RZ.CDFILIAL = FILIOPERLOJACAIXTUR.CDFILIAL
       AND RZ.CDCAIXA = FILIOPERLOJACAIXTUR.CDCAIXA
       AND RZ.NRORG   = FILIOPERLOJACAIXTUR.NRORG
       AND RZ.DTREDUCAOZ  = FILIOPERLOJACAIXTUR.DTMOVTURCAIX
       WHERE (TRUNC(RZ.DTREDUCAOZ) BETWEEN NVL(:DATAINI, SYSDATE-30) AND NVL(:DATAFIN, SYSDATE))
         AND (( INSTR(:STATUS, RZ.IDSTATUS) >0 ) OR ( :STATUS = 'T' ) )
         AND (( INSTR(:IDORIGEMREDZ, '_' || RZ.IDORIGEMREDZ || '_') >0 ) OR ( :IDORIGEMREDZ = 'T' ) )
         AND VRVENBRUREDZ <> 0
         AND VRVENLIQREDZ <> 0

      UNION ALL

      SELECT DISTINCT V.CDFILIAL||' - '||FILIOPERLOJACAIXTUR.NMFILIAL||' Loja: '||FILIOPERLOJACAIXTUR.CDLOJA||' - '||FILIOPERLOJACAIXTUR.NMLOJA AS LABELFILIAL,
         V.CDCAIXA||' - '||FILIOPERLOJACAIXTUR.NMCAIXA AS LABELCAIXA,
         CASE V.IDAPROVACAONFCE
               WHEN 'P' THEN 'Pendente'
               WHEN 'E' THEN 'Com Erro'
               WHEN 'A' THEN 'Aprovada'
               ELSE V.IDAPROVACAONFCE
             END AS IDSTATUS, V.CDFILIAL, V.CDCAIXA, 
             DECODE(V.IDTPEMISVEND,'N','NFCE','S','SAT') AS IDORIGEMREDZ, V.NRORG, 
             V.DTENTRVENDA AS DTREDUCAOZ
        FROM VENDA V
        JOIN (SELECT FILIOPERLOJACAIX.CDCAIXA, FILIOPERLOJACAIX.NMCAIXA, FILIOPERLOJACAIX.CDFILIAL, FILIOPERLOJACAIX.NMFILIAL, FILIOPERLOJACAIX.CDLOJA, FILIOPERLOJACAIX.NMLOJA, FILIOPERLOJACAIX.NRORG, T.DTFECHCAIX, T.DTMOVTURCAIX
              FROM TURCAIXA T
                JOIN (SELECT C.CDCAIXA, C.NMCAIXA, FILIOPERLOJA.CDFILIAL, FILIOPERLOJA.NMFILIAL, FILIOPERLOJA.CDLOJA, FILIOPERLOJA.NMLOJA, FILIOPERLOJA.NRORG
                        FROM CAIXA C
                        JOIN (SELECT L.CDLOJA, L.NMLOJA, FILIOPER.CDFILIAL, FILIOPER.NMFILIAL, FILIOPER.NRORG
                                FROM LOJA L
                                JOIN (SELECT FO.CDFILIAL, F.NMFILIAL, FO.NRORG
                                        FROM FILIAL F
                                        JOIN (SELECT FO.CDFILIAL, FO.NRORG
                                                FROM FILIOPER FO
                                               WHERE FO.CDOPERADOR = :CDOPERADOR
                                                 AND FO.NRORG = :NRORG
                                             ) FO
                                          ON F.CDFILIAL = FO.CDFILIAL
                                         AND F.NRORG = FO.NRORG
                                       WHERE ( ( INSTR(:CDFILIAL, F.CDFILIAL) >0 ) OR ( :CDFILIAL = 'T' ) )
                                     )FILIOPER
                                  ON FILIOPER.CDFILIAL = L.CDFILIAL
                                 AND FILIOPER.NRORG = L.NRORG
                             )FILIOPERLOJA
                          ON FILIOPERLOJA.CDFILIAL = C.CDFILIAL
                         AND FILIOPERLOJA.CDLOJA = C.CDLOJA
                         AND FILIOPERLOJA.NRORG = C.NRORG 
                       WHERE ( ( INSTR(:CDCAIXA, FILIOPERLOJA.CDFILIAL ||C.CDCAIXA) >0 ) OR ( :CDCAIXA = 'T' ) )
                     )FILIOPERLOJACAIX
                  ON FILIOPERLOJACAIX.CDCAIXA = T.CDCAIXA
                 AND FILIOPERLOJACAIX.CDFILIAL = T.CDFILIAL
                 AND FILIOPERLOJACAIX.NRORG = T.NRORG
                 AND T.DTFECHCAIX IS NOT NULL
             )FILIOPERLOJACAIXTUR
          ON FILIOPERLOJACAIXTUR.CDFILIAL = V.CDFILIAL
         AND FILIOPERLOJACAIXTUR.CDLOJA = V.CDLOJA
         AND FILIOPERLOJACAIXTUR.CDCAIXA = V.CDCAIXA
         AND FILIOPERLOJACAIXTUR.NRORG = V.NRORG
         AND FILIOPERLOJACAIXTUR.DTMOVTURCAIX = V.DTENTRVENDA
       WHERE V.IDTPEMISVEND IN ('N','S')
         AND ( TRUNC(V.DTENTRVENDA) BETWEEN NVL(:DATAINI, SYSDATE-30) AND NVL(:DATAFIN, SYSDATE))
         AND ( ( INSTR(:STATUS, V.IDAPROVACAONFCE) >0 ) OR ( :STATUS = 'T' ) )
         AND V.IDTPAMBNFCE  = '1'
         AND V.IDSTATUSNFCE = 'A'
       ORDER BY DTREDUCAOZ, CDCAIXA
  ";
}